#include "stdlib.h"
#include "stdio.h" 
#include "fxlib.h"

#include "MonochromeLib.h"
#include "key.h"
#include "time.h"
#include "hero.h"
#include "rocks.h"


#define ROCKS_NUMBER 5


unsigned char small_rock[] = {0x0F, 0x00, 0x3F, 0xC0, 0x70, 0xE0, 0x60, 0x60, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0xC0, 0x30, 0x60, 0x60, 0x70, 0xE0, 0x3F, 0xC0, 0x0F, 0x00};
unsigned char big_rock[] = {0x01, 0xE0, 0x00, 0x07, 0xF8, 0x00, 0x1E, 0x1E, 0x00, 0x38, 0x07, 0x00, 0x30, 0x03, 0x00, 0x60, 0x01, 0x80, 0x60, 0x01, 0x80, 0xC0, 0x00, 0xC0, 0xC0, 0x00, 0xC0, 0xC0, 0x00, 0xC0, 0xC0, 0x00, 0xC0, 0x60, 0x01, 0x80, 0x60, 0x01, 0x80, 0x30, 0x03, 0x00, 0x38, 0x07, 0x00, 0x1E, 0x1E, 0x00, 0x07, 0xF8, 0x00, 0x01, 0xE0, 0x00};
unsigned char * rocks_bmp[] = {small_rock, big_rock};

unsigned char stop_right[] = {0x5E, 0x00, 0x7F, 0x80, 0x71, 0x80, 0x25, 0x00, 0x45, 0x00, 0x31, 0x00, 0x2E, 0x00, 0x2D, 0x00, 0x29, 0x00, 0x12, 0x00, 0x1C, 0x00, 0x1E, 0x00};
unsigned char run_right_1[] = {0x5E, 0x00, 0x7F, 0x80, 0x71, 0x80, 0x25, 0x00, 0x45, 0x00, 0x31, 0x80, 0x4E, 0x80, 0x4D, 0x00, 0x33, 0x80, 0x67, 0x80, 0x7B, 0x00, 0x60, 0x00};
unsigned char run_right_2[] = {0x5E, 0x00, 0x7F, 0x80, 0x71, 0x80, 0x25, 0x00, 0x45, 0x00, 0x31, 0x00, 0x4E, 0x00, 0x2E, 0x00, 0x61, 0x00, 0x79, 0x00, 0x67, 0x00, 0x07, 0x80};
unsigned char stop_left[] = {0x1E, 0x80, 0x7F, 0x80, 0x63, 0x80, 0x29, 0x00, 0x28, 0x80, 0x23, 0x00, 0x1D, 0x00, 0x2D, 0x00, 0x25, 0x00, 0x12, 0x00, 0x0E, 0x00, 0x1E, 0x00};
unsigned char run_left_1[] = {0x1E, 0x80, 0x7F, 0x80, 0x63, 0x80, 0x29, 0x00, 0x28, 0x80, 0x63, 0x00, 0x5C, 0x80, 0x2C, 0x80, 0x73, 0x00, 0x79, 0x80, 0x37, 0x80, 0x01, 0x80};
unsigned char run_left_2[] = {0x1E, 0x80, 0x7F, 0x80, 0x63, 0x80, 0x29, 0x00, 0x28, 0x80, 0x23, 0x00, 0x1C, 0x80, 0x1D, 0x00, 0x21, 0x80, 0x27, 0x80, 0x39, 0x80, 0x78, 0x00};
unsigned char jump[] = {0x5E, 0x00, 0x7F, 0x80, 0x71, 0x80, 0x25, 0x00, 0x45, 0x80, 0xB1, 0x40, 0x4E, 0x80, 0x2D, 0x00, 0x21, 0x00, 0xF3, 0xC0, 0xFF, 0xC0, 0x61, 0x80};
unsigned char * hero_bmp[] = {stop_right, run_right_1, run_right_2, stop_left, run_left_1, run_left_2, jump};


char* int2str(char* c, unsigned int n) {
    if(n==0) {
        c[0] = '0';
        c[1] = 0;
    } else {
        int i, l=0;
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}
void game_over() {
	int i;
	PrintXY(35, 20, "Game Over", 0);
	ML_display_vram();
	IsKeyDown(KEY_CTRL_EXE);
	while(i != KEY_CTRL_EXE) GetKey(&i);
}

void pause() {
	int i, j;
	char* vram = ML_vram_adress();
	char bmp[] = {255, 255, 255, 255, 255, 255, 255, 255, 195, 140, 152, 67, 201, 36, 147, 207, 195, 4, 152, 199, 207, 36, 158, 79, 207, 38, 48, 195, 255, 255, 255, 255, 255, 255, 255, 255};
	for(i=0 ; i<9 ; i++) {
		for(j=0 ; j<4 ; j++)
			vram[(i+28<<4)+j+6] = bmp[(i<<2)+j];
	}
	IsKeyDown(KEY_CTRL_EXE);
	while(i != KEY_CTRL_EXE) GetKey(&i);
}

int collision(int x, int y, Rock * rock) {
	if ( (rock->x + rock->size - x) * (rock->x + rock->size - x) + (rock->y + rock->size - y) * (rock->y + rock->size - y) <= (rock->size * rock->size) ) {
		return 1;
	} else {
		return 0;
	}
}

int AddIn_main(int isAppli, unsigned short OptionNum) {	
	int i, j, k, l;
	int dx, dy;	
	
	char fps_char[10], points_char[50];
	int fps = 0, fps_frame, fps_last_time;
	
	int gameover = 0;
	int points = 0;	
	
	Rock * rocks[ROCKS_NUMBER];
	int rocks_last_update;
	
	Hero * hero;

	srand(time_getTicks()+5645673);
	
	fps_last_time = time_getTicks();
	
	// Init hero
	hero = hero_create(hero_bmp);

	
	
	
	
	// Init rocks
	for(i=0;i<ROCKS_NUMBER;i++) rocks[i] = NULL;
	
	rocks[i] = rock_create(rocks_bmp);
	
	
	
	while(1) {
		ML_clear_vram();
		
		/// Update
		
		// Begin
		
		// Hero update
		hero_update(hero);
		
		if(!gameover) {
			if(key_down(K_RIGHT) && hero->dx <= 0)
				hero_right_start(hero);			
			if(key_down(K_LEFT) && hero->dx >= 0)
				hero_left_start(hero);		
			if( (!key_down(K_LEFT) && !key_down(K_RIGHT) ) && hero->dx != 0)
				hero_stop(hero);
		}		
	
		
		// Rocks
		if(time_getTicks() - rocks_last_update > 2) {
			// Update rocks
			for(i=0;i<ROCKS_NUMBER;i++) {
				if(rocks[i] != NULL) {
					rock_update(rocks[i]);
					
					// Hero colision
					if(rocks[i]->sub_1 != NULL && rocks[i]->sub_2 != NULL) {
						if( collision(hero->x, hero->y, rocks[i]->sub_1) || collision(hero->x+10, hero->y+10, rocks[i]->sub_1) )
							gameover = 1;
						if( collision(hero->x, hero->y, rocks[i]->sub_2) || collision(hero->x+10, hero->y+10, rocks[i]->sub_2) )
							gameover = 1;
					} else if(collision(hero->x, hero->y, rocks[i]) || collision(hero->x+10, hero->y+10, rocks[i]) ) {
						gameover = 1;
					}
				}
			}
			/// God mode :)
			// gameover = 0;
		
			rocks_last_update = time_getTicks();
			
			// Score
			if(!gameover) {
				points += 3;
			}
		}
			
		
		// Fps
		if(time_getTicks()-fps_last_time>128) { 
			fps = fps_frame;
			if(fps < 0 || fps > 1000) fps = 0;
			fps_frame = 0;
			fps_last_time = time_getTicks();
			
			// Add a rock per second
			for(i=0;i<ROCKS_NUMBER;i++) {
				if(rocks[i] == NULL) {
					rocks[i] = rock_create(rocks_bmp);
					break;
				}
			}

		}
		fps_frame++;
		
		// End Update		
		
		/// Draw
		
		// Begin
		
		// Background
		ML_horizontal_line(61, 0, 127, ML_BLACK);
		ML_horizontal_line(62, 0, 127, ML_BLACK);
		ML_horizontal_line(63, 0, 127, ML_BLACK);
		
		// Rocks
		for(i=0;i<ROCKS_NUMBER;i++) {
			if(rocks[i] != NULL) {
				if(rocks[i]->type == BIG) {
					if(rocks[i]->sub_1 == NULL && rocks[i]->sub_2 == NULL)
						ML_bmp_or_cl(rocks[i]->bmp[1], rocks[i]->x, rocks[i]->y, 18, 18);
					else {
						ML_bmp_or_cl(rocks[i]->sub_1->bmp[0], rocks[i]->sub_1->x, rocks[i]->sub_1->y, 12, 12);
						ML_bmp_or_cl(rocks[i]->sub_2->bmp[0], rocks[i]->sub_2->x, rocks[i]->sub_2->y, 12, 12);
					}
				}
				else if(rocks[i]->type == SMALL) ML_bmp_or_cl(rocks[i]->bmp[0], rocks[i]->x, rocks[i]->y, 12, 12);
			}
		}
		
		// Hero
		ML_bmp_or_cl(hero->bmp[hero->anim_bmp], hero->x, hero->y, 10, 12);
		if(hero->x + 12 > 127) {
			ML_bmp_or_cl(hero->bmp[hero->anim_bmp], (hero->x)-128, hero->y, 10, 12);
		}
		if(hero->x < 0) {
			ML_bmp_or_cl(hero->bmp[hero->anim_bmp], (hero->x)+128, hero->y, 10, 12);
		}
		
		// Hud
		int2str(fps_char, fps);
		// int2str(fps_char, (int) map_dx);		
		PrintMini(127-15, 1, fps_char, 0);
		
		int2str(points_char, (int) points);
		PrintMini(1, 1, points_char, 0);
		
		// End		
		
		if(gameover) { // Game over
			hero_jump_start(hero);
			hero->anim_isfall = 1;
			if(hero->y > 64) {
				game_over();
				
				points = 0;				
				
				hero_reset(hero);
				
				for(i=0;i<ROCKS_NUMBER;i++) {
					if(rocks[i] != NULL) {
						if(rocks[i]->sub_1 != NULL && rocks[i]->sub_2 != NULL) {
							free(rocks[i]->sub_1);
							free(rocks[i]->sub_2);
							rocks[i]->sub_1 = NULL;
							rocks[i]->sub_2 = NULL;
						}
						free(rocks[i]);
						rocks[i] = NULL;
					}
				}
				
				gameover = 0;
			}
		}	
		
		if(key_down(K_EXIT))
			pause();
		
		ML_display_vram();
		
		Sleep(10);
    }

    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

