#include "hero.h"
#include "time.h"

#define HERO_SPEED_DX 3
#define JUMP_DY -5
#define JUMP_AY 0.45

Hero * hero_create(unsigned char ** bmp) {
	Hero * hero = (Hero *) malloc(sizeof(Hero));	
	hero->x = 55;	
	hero->y = 61-12;
	hero->dx = 0;	
	hero->dy = 0;
	hero->ax = 0;	
	hero->ay = 0;
	hero->x_stop = -1;
	hero->y_stop = -1;
	hero->bmp = bmp;
	hero->anim = STOP_RIGHT;
	hero->anim_tick = 0;
	hero->anim_bmp = 0;
	hero->anim_isjmp = 0;
	hero->anim_isfall = 0;
	hero->last_update = 0;
	return hero;
}
void hero_reset(Hero * hero) {
	hero->x = 55;	
	hero->y = 61-12;
	hero->dx = 0;	
	hero->dy = 0;
	hero->ax = 0;	
	hero->ay = 0;
	hero->x_stop = -1;
	hero->y_stop = -1;
	hero->anim = STOP_RIGHT;
	hero->anim_tick = 0;
	hero->anim_bmp = 0;
	hero->anim_isjmp = 0;
	hero->anim_isfall = 0;
	hero->last_update = 0;
}
void hero_jump_start(Hero * hero) {
	if(!hero->anim_isjmp) {
		hero->dy = JUMP_DY;
		hero->ay = JUMP_AY;		
		hero->anim_isjmp = 1;
		hero->anim_bmp = 6;
		hero->anim = JUMP;
	}
}
void hero_jump_reset(Hero * hero) {
	if(hero->anim_isjmp) {
		hero->dy = 0;
	}
}
void hero_jump_stop(Hero * hero, int y) {
	if(hero->anim_isjmp) {		
		hero->y = y;
		hero->dy = 0;
		hero->ay = 0;
		hero->anim_isjmp = 0;
		hero->anim_isfall = 0;
		hero->anim_bmp = 1;
	}
}
void hero_falling_start(Hero * hero) {
	if(!hero->anim_isjmp) {
		hero->ay = JUMP_AY;		
		hero->anim_isjmp = 1;
		hero->anim_isfall = 1;
		hero->anim_bmp = 6;
		hero->anim = JUMP;
	}
}
void hero_right_start(Hero * hero) {
	hero->anim = RIGHT;
	hero->anim_bmp = 1;
	
	hero->dx = HERO_SPEED_DX;
}
void hero_left_start(Hero * hero) {
	hero->anim = LEFT;
	hero->anim_bmp = 4;
	
	hero->dx = - HERO_SPEED_DX;
}
void hero_stop(Hero * hero) {
	if(hero->anim == RIGHT) {
		hero->anim = STOP_RIGHT;
		hero->anim_bmp = 0;
	} else if (hero->anim == LEFT) {
		hero->anim = STOP_LEFT;
		hero->anim_bmp = 3;
	} else {
		hero->anim = STOP_RIGHT;
		hero->anim_bmp = 0;
	}
	
	hero->dx = 0;
}


void hero_update(Hero * hero) {
	// Update mouvement
	if(time_getTicks() - hero->last_update > 2) {
		hero->dx += hero->ax;
		hero->dy += hero->ay ;
		
		hero->x += hero->dx;
		hero->y += hero->dy;
		hero->last_update = time_getTicks();
	}
	
	// Position update
	if(hero->x > 127 + 6)
		hero->x -= 128;
	
	if(hero->x < -6)
		hero->x += 128;
	
	// Update bmp
	if(time_getTicks()-hero->anim_tick > 15) {
		hero->anim_tick = time_getTicks();
		
		if(hero->anim == RIGHT && hero->anim_bmp == 1)
			hero->anim_bmp = 2;
		else if(hero->anim == RIGHT && hero->anim_bmp == 2)
			hero->anim_bmp = 1;
			
		if(hero->anim == LEFT && hero->anim_bmp == 4)
			hero->anim_bmp = 5;
		else if(hero->anim == LEFT && hero->anim_bmp == 5)
			hero->anim_bmp = 4;
	}
}