#ifndef _HERO
#define _HERO

typedef enum {
	STOP_LEFT = 0, STOP_RIGHT = 1,
	LEFT = 2, RIGHT = 3,
	JUMP = 4
} Anim;

typedef struct {
	double x, y;
	double dx, dy;
	double ax, ay;
	int x_stop, y_stop;
	unsigned char ** bmp;
	Anim anim;
	int anim_tick, anim_bmp, anim_isjmp, anim_isfall;
	int last_update;
} Hero;

// Construction
Hero * hero_create(unsigned char ** bmp);
void hero_reset(Hero * hero);

// Movement
void hero_jump_start(Hero * hero);
void hero_jump_reset(Hero * hero);
void hero_falling_start(Hero * hero);
void hero_jump_stop(Hero * hero, int y);
void hero_right_start(Hero * hero);
void hero_left_start(Hero * hero);
void hero_stop(Hero * hero);


// Event
void hero_update(Hero * hero);

#endif //_HERO