#include "stdlib.h"
#include "stdio.h" 
#include "fxlib.h"

#include "rocks.h"
#include "time.h"

#define FIRST_DY -4

int rand_int(int min, int max) {
	return rand()%(max-min+1)+min;
}

Rock * rock_create(unsigned char ** bmp) {
	Rock * rock = (Rock *) malloc(sizeof(Rock));
	
	rock_generate(rock);
	
	rock->bmp = bmp;
	
	return rock;
}
Rock * rock_create2(Rock * big, int position) {
	Rock * rock = (Rock *) malloc(sizeof(Rock));
	
	rock->x = big->x + position;
	rock->y = big->y - 5;
	if(position > 0)
		rock->dx = 1;
	else
		rock->dx = -1;
	rock->dy = 1;
	rock->last_dy = 0;
	rock->ax = 0;
	rock->ay = 0.2;
	rock->bounce_nb = 0;
	
	
	rock->bmp = big->bmp;
	
	rock->size = 6;
	rock->type = SMALL;
	rock->isdivided = 1;
	rock->sub_1 = NULL;
	rock->sub_2 = NULL;
	
	return rock;
}


void rock_generate(Rock * rock) {
	rock->dx = rand_int(-2, 2);
	if(rock->dx == -1) rock->dx = -0.5;
	else if(rock->dx == 1) rock->dx = 0.5;
	else if(rock->dx == -2) rock->dx = -1;
	else if(rock->dx == 2) rock->dx = 1; 
	
	if(rock->dx > 0) 
		rock->x = rand_int(0,50);
	else if (rock->dx < 0)
		rock->x = rand_int(50,110);
	else
		rock->x = rand_int(0,110);
		
	rock->y = -20;	
	rock->dy = 0;
	rock->last_dy = 0;
	rock->ax = 0;
	rock->ay = 0.1;
	rock->bounce_nb = 0;
	
	if(rand_int(0,3) <= 2) {
		rock->size = 6;
		rock->type = SMALL;
		rock->isdivided = 1;
		rock->sub_1 = NULL;
		rock->sub_2 = NULL;
	} else {
		rock->size = 9;
		rock->type = BIG;
		rock->isdivided = 0;
	}
	
}

void rock_apply_physics(Rock * rock) {
	rock->dx += rock->ax;
	rock->dy += rock->ay ;
	
	rock->x += rock->dx;
	rock->y += rock->dy;
	
	if(rock->y + 2 * rock->size >= 61) {
		if(rock->last_dy == 0) rock->last_dy = FIRST_DY;
		rock->last_dy /= (double) (1.27);
		rock->dy = rock->last_dy;
		rock->bounce_nb++;
	}
}

void rock_update(Rock * rock) {
	if(time_getTicks() - rock->last_update > 2) {
		rock_apply_physics(rock);
		
		if(rock->sub_1 != NULL && rock->sub_2 != NULL) {
			rock_apply_physics(rock->sub_1);
			rock_apply_physics(rock->sub_2);
			
			if(rock->sub_1->bounce_nb > 4) {
				free(rock->sub_1);
				free(rock->sub_2);
				rock->sub_1 = NULL;
				rock->sub_2 = NULL;
				rock_generate(rock);
			}
		}
		
		if(rock->type == SMALL && rock->bounce_nb > 4) {
			rock_generate(rock);
		}
		if(rock->type == BIG && rock->bounce_nb > 2 && !rock->isdivided) {
			rock->sub_1 = rock_create2(rock, - 3);
			rock->sub_2 = rock_create2(rock, + 3);
			rock->isdivided = 1;			
		}
		
	}
}